from globals import logger
import config
from consts import *
from utils import *

def getTableGui(id, td, pageMenuLen = 50):
    table = ""
    table += '<table border="0" cellspacing="2">\n'

    # Title

    table += '<tr>'
    table += '<th colspan="' + str(len(td.cols)) + '">' + td.title + " ["
    if hasattr(td, "dataCount"):
        table += 'count=' + str(td.dataCount) + ', '
    else:
        table += 'count=' + str(len(td.data)) + ', '
    table += "query=" + str(int(td.qtime)) + "ms"
    if td.atime > 10:
        table += ', analysis=' + str(int(td.atime)) + "ms"
#    if hasattr(td, "dataCount"):
#        table += ", numrows = " + str(td.dataCount);
    table += "]</th>"
    table += '</tr>\n'

    # Paging

    if hasattr(td, "dataCount"):
        all = "All "
        if td.dataCount > td.pageSize:
            table += '<tr>\n'
            table += '<td colspan="' + str(len(td.cols)) + '">'
            if td.page != None:
                table += '<a href="' + formGetParameters({id + "_p" : "all"}) + '">'
            table += all
            if td.page != None:
                table += '</a>'
            r = td.dataCount / td.pageSize
            if td.dataCount % td.pageSize != 0:
                r += 1
            numchars = len(all)
            for i in range(r):
                if i != td.page:
                    table += '<a href="' + formGetParameters({id + "_p" : i}) + '">'
                caption = str(i + 1) + " "
                table += caption
                numchars += len(caption)
                if i != td.page:
                    table += "</a>"
                if numchars >= pageMenuLen:
                    table += "<br />"
                    numchars = 0
            table += '</td>\n'
            table += '</tr>\n'

    # Orderby

    table += "<tr>"
    for i in range(0, len(td.cols)):
        table += '<td style="background-color:#b9d0de">'
        if td.orderby == i:
            if td.asc == True:
                table += '<img src="/' + PROJECT_NAME + '/images/orderasc.png" alt="" />'
            else:
                table += '<img src="/' + PROJECT_NAME + '/images/orderdesc.png" alt="" />'
        table += '<a href="'
        value = str(i) + "_"
        if td.orderby == i :
            value += str(not td.asc)
        else:
            value += str(False)
        params = {}
        params[id] = value
        table += formGetParameters(params)
        table += '">' \
            + str(td.cols[i].title) \
            + "</a>"
        if (td.cols[i].info != None):
            if i == 0:
                table += buildTooltip(td.cols[i].info, width=200, pos=0)
            elif i == len(td.cols) - 1:
                table += buildTooltip(td.cols[i].info, width=200, pos=-200)
            else:
                table += buildTooltip(td.cols[i].info, width=200, pos=-100)
        table += "</td>"
    table += "</tr>\n"

    # Body

    start = 0 * config.PAGE_SIZE;
#    for j in range (start, start + consts.PAGE_SIZE):
    for j in range(len(td.data)):
        if (j >= len(td.data)): break;
        table += "<tr>"
        for i in range(0, len(td.cols)):
            cell = td.data[j][i]
            if td.cols[i].decorator != None:
                cell = td.cols[i].decorator(cell)
            table += "<td "
            if (j % 2 == 0):
                table += 'style="background-color:white"'
            table += ">" + str(cell) + "</td>"
        table += "</tr>\n"
        j += 1

    table += "</table>"
    return table

def getVertTableGui(id, td):
    table = ""
    table += '<table border="0">\n'
    table += '<tr>'
    table += '<th colspan="' + str(len(td.data) + 1) + '">' + str(td.title) + " " + "[" + str(int(td.qtime)) + "ms]" + "</th>"
    table += '</tr>\n'

    for i in range(len(td.cols)):
        table += "<tr>"
        table += "<td "
        if (i % 2 == 0):
            table += 'style="background-color:white"'
        table += ">" + td.cols[i].title + "</td>"
        for j in range(len(td.data)):
            if (i < len(td.data[j])):
                table += "<td "
                if (i % 2 == 0):
                    table += 'style="background-color:white"'
                cell = td.data[j][i]
                if td.cols[i].decorator != None:
                    cell = td.cols[i].decorator(cell)
                table += ">" + str(cell) + "</td>"
        table += "</tr>"

    table += "</table>"
    return table
