from sqlalchemy import *

import time
import datetime

import config
import globals

connection = None

def initBasicConnection():
    """
    Connect to DB

    Connect to DB using sqlalchemy using cx_oracle
    """
    global connection
    if (connection == None):
        engine = create_engine('oracle://' + config.DB_USER + ":" + \
            config.DB_PASSWORD + "@" + config.DB_TNS)

        globals.dbMeta = MetaData()
        globals.dbMeta.bind = engine

        connection = engine.connect()

def executeQuery(query, bindParams = None):
    if (connection == None):
        initBasicConnection()
    start = datetime.datetime.now()
    try:
        if (bindParams != None):
            queryResult = connection.execute(query, bindParams)
        else:
            queryResult = connection.execute(query)
    except StandardError, ex:
        # connection.close()
        raise RuntimeError, "Failed to query : %s\n" % str(ex)
    delta = datetime.datetime.now() - start
    queryResult.time = delta.seconds * 1000 + delta.microseconds / float(1000)
    # connection.close()
    return queryResult
